using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Reflector.Library;

namespace CassiniViewer
{
	/// <summary>
	/// Summary description for CassiniViewer.
	/// </summary>
	public class CassiniViewer : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu MainMenu;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ComboBox cmbUrls;
		private System.Windows.Forms.ToolBar Toolbar;
		private System.Windows.Forms.ToolBarButton btnBack;
		private System.Windows.Forms.ToolBarButton btnForward;
		private System.Windows.Forms.ToolBarButton btnRefresh;
		private System.Windows.Forms.ToolBarButton btnHome;
		private System.Windows.Forms.Label label1;

		private CassiniForm ConfigForm = null;
		private System.Windows.Forms.ToolBarButton btnExit;
		private string CurrentUrl = "";
		private System.Windows.Forms.ImageList Images;

		private Reflector.Library.HtmlBrowser oBrowser;
		private System.Windows.Forms.StatusBar Status;
		private bool UrlSet = false;

		public CassiniViewer(string[] Args) 
		{
			InitializeComponent();

			Application.DoEvents();

			oBrowser = new Reflector.Library.HtmlBrowser();
			oBrowser.Parent = this;
			oBrowser.Location = new System.Drawing.Point(0, 70);
			this.Width = this.Width + 1;
			oBrowser.NavigateComplete += new Reflector.Library.BrowserNavigateEventHandler(oBrowser_NavigateComplete);
			oBrowser.BeforeNavigate +=new BrowserNavigateEventHandler(oBrowser_BeforeNavigate);
			oBrowser.StatusTextChange +=new BrowserStatusTextChangeEventHander(oBrowser_StatusTextChange);
			oBrowser.Visible = true;
	
			
			ConfigForm = new CassiniForm(Args);
			ConfigForm.Visible = false;
		}

		private string GetStartUrl() 
		{
			return "http://localhost:" + CassiniForm._portString + CassiniForm._virtRoot;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CassiniViewer));
			this.MainMenu = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.Images = new System.Windows.Forms.ImageList(this.components);
			this.cmbUrls = new System.Windows.Forms.ComboBox();
			this.Toolbar = new System.Windows.Forms.ToolBar();
			this.btnBack = new System.Windows.Forms.ToolBarButton();
			this.btnForward = new System.Windows.Forms.ToolBarButton();
			this.btnRefresh = new System.Windows.Forms.ToolBarButton();
			this.btnHome = new System.Windows.Forms.ToolBarButton();
			this.btnExit = new System.Windows.Forms.ToolBarButton();
			this.label1 = new System.Windows.Forms.Label();
			this.Status = new System.Windows.Forms.StatusBar();
			this.SuspendLayout();
			// 
			// MainMenu
			// 
			this.MainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItem1,
																					 this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			this.menuItem1.Text = "File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "E&xit";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem4});
			this.menuItem3.Text = "Tools";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.Text = "Configuration...";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// Images
			// 
			this.Images.ImageSize = new System.Drawing.Size(24, 24);
			this.Images.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("Images.ImageStream")));
			this.Images.TransparentColor = System.Drawing.Color.Black;
			// 
			// cmbUrls
			// 
			this.cmbUrls.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmbUrls.Location = new System.Drawing.Point(64, 41);
			this.cmbUrls.Name = "cmbUrls";
			this.cmbUrls.Size = new System.Drawing.Size(704, 21);
			this.cmbUrls.TabIndex = 2;
			this.cmbUrls.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cmbUrls_KeyPress);
			this.cmbUrls.SelectedValueChanged += new System.EventHandler(this.cmbUrls_SelectedValueChanged);
			// 
			// Toolbar
			// 
			this.Toolbar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.btnBack,
																					   this.btnForward,
																					   this.btnRefresh,
																					   this.btnHome,
																					   this.btnExit});
			this.Toolbar.ButtonSize = new System.Drawing.Size(150, 30);
			this.Toolbar.DropDownArrows = true;
			this.Toolbar.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Toolbar.ImageList = this.Images;
			this.Toolbar.Location = new System.Drawing.Point(0, 0);
			this.Toolbar.Name = "Toolbar";
			this.Toolbar.ShowToolTips = true;
			this.Toolbar.Size = new System.Drawing.Size(976, 36);
			this.Toolbar.TabIndex = 0;
			this.Toolbar.TextAlign = System.Windows.Forms.ToolBarTextAlign.Right;
			this.Toolbar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.Toolbar_ButtonClick);
			// 
			// btnBack
			// 
			this.btnBack.ImageIndex = 1;
			this.btnBack.Text = "Back";
			// 
			// btnForward
			// 
			this.btnForward.ImageIndex = 2;
			this.btnForward.Text = "Forward";
			// 
			// btnRefresh
			// 
			this.btnRefresh.ImageIndex = 4;
			this.btnRefresh.Text = "Refresh";
			// 
			// btnHome
			// 
			this.btnHome.ImageIndex = 3;
			this.btnHome.Text = "Home";
			// 
			// btnExit
			// 
			this.btnExit.Text = "Exit";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 44);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Address:";
			// 
			// Status
			// 
			this.Status.Location = new System.Drawing.Point(0, 562);
			this.Status.Name = "Status";
			this.Status.Size = new System.Drawing.Size(976, 22);
			this.Status.TabIndex = 3;
			// 
			// CassiniViewer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(976, 584);
			this.Controls.Add(this.Status);
			this.Controls.Add(this.Toolbar);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.cmbUrls);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.MainMenu;
			this.Name = "CassiniViewer";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Offline Web Viewer";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.CassiniViewer_Closing);
			this.SizeChanged += new System.EventHandler(this.CassiniViewer_SizeChanged);
			this.Load += new System.EventHandler(this.CassiniViewer_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			this.ConfigForm.Show();
		}


		private void oBrowser_NavigateComplete(object sender, BrowserNavigateEventArgs e)
		{
			// *** Remove any instances of the item
			this.cmbUrls.Items.Remove(e.Url);

			// *** Add it back in
			this.cmbUrls.Items.Insert(0,e.Url);
			if (this.cmbUrls.Items.Count > 20) 
				this.cmbUrls.Items.RemoveAt(this.cmbUrls.Items.Count-1);

			this.UrlSet = true;
			this.cmbUrls.Text = (string) e.Url;
			this.CurrentUrl = (string) e.Url;
		}


		/// <summary>
		/// Navigate the Web Browser Control
		/// </summary>
		/// <param name="lcUrl"></param>
		private void Navigate(string lcUrl) 
		{
			this.oBrowser.Navigate(lcUrl); 
		}


		private void cmbUrls_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == 13) 
				this.Navigate(this.cmbUrls.Text);

		}
		private void cmbUrls_SelectedValueChanged(object sender, System.EventArgs e)
		{
			if (!this.UrlSet)
			{
				this.Navigate(this.cmbUrls.Text);
				this.CurrentUrl = this.cmbUrls.Text;
			}
			else 
			{
				this.UrlSet = false; 
			}
		}
		
		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		protected override void OnClosing(CancelEventArgs e)
		{
			this.ConfigForm.Close();
			this.ConfigForm = null;

			base.OnClosing (e);
		}

		private void CassiniViewer_SizeChanged(object sender, System.EventArgs e)
		{
			this.oBrowser.Width = this.Width-8;
			
			this.oBrowser.Height = this.Height - this.oBrowser.Top - this.Toolbar.Height - 10 - this.Status.Height;
		}

		private void Toolbar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			string buttonText = e.Button.Text;

			switch(buttonText) 
			{
				case "Back":
					try 
					{
						this.oBrowser.GoBack();
					}
					catch {;}

					break;
				case "Forward":
					try 
					{
						this.oBrowser.GoForward();
					}
					catch {;}
					break;
				case "Home":
					this.Navigate(this.GetStartUrl());
					break;
				case "Refresh":
					this.Navigate(this.cmbUrls.Text);
					break;
			}
			
		}

		private void oBrowser_BeforeNavigate(Object s, BrowserNavigateEventArgs e)
		{
			string x = e.Url;
			byte[] y = e.PostBuffer;
			string z= e.Headers;
		}

		private void oBrowser_StatusTextChange(object s, BrowserStatusTextChangeEventArgs e)
		{
			this.Status.Text = " " + e.StatusText;
		}

		private void CassiniViewer_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (this.ConfigForm != null) 
			{
				ConfigForm.ShutDown = true;
				ConfigForm.Close();
				ConfigForm = null;
			}

			Application.Exit();
		}

		
		/// <summary>
		/// Starts the Web Server and navigates to the
		/// home url.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void CassiniViewer_Load(object sender, System.EventArgs e)
		{
	
			Application.DoEvents();

			this.Toolbar.Appearance = ToolBarAppearance.Flat;

			// *** Start the Web Server
			ConfigForm.Start();
			
			this.Navigate( this.GetStartUrl() );
		}

	}
}
