using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace CassiniViewer
{
	/// <summary>
	/// Summary description for Splash.
	/// </summary>
	public class Splash : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Timer oTimer;
		private System.ComponentModel.IContainer components;

		public int Timeout
		{
			get { return this.nTimeout; }
			set { 
				#if SHAREWARE
					this.nTimeout = value; 
				#else
				if (value == 0)
					  this.oTimer.Interval = 3000;
				  else
					  this.oTimer.Interval = value * 1000;

	              this.nTimeout = value; 
				#endif
				}
		}
		int nTimeout = 0;

		public bool bSplash = false;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.PictureBox oPicture;

		public Splash()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		public Splash(bool bSplash) 
		{
			InitializeComponent();
			this.bSplash = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Splash));
			this.oTimer = new System.Windows.Forms.Timer(this.components);
			this.oPicture = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.button2 = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.SuspendLayout();
			// 
			// oTimer
			// 
			this.oTimer.Enabled = true;
			this.oTimer.Interval = 5000;
			this.oTimer.Tick += new System.EventHandler(this.oTimer_Tick);
			// 
			// oPicture
			// 
			this.oPicture.Image = ((System.Drawing.Image)(resources.GetObject("oPicture.Image")));
			this.oPicture.Location = new System.Drawing.Point(0, 0);
			this.oPicture.Name = "oPicture";
			this.oPicture.Size = new System.Drawing.Size(400, 320);
			this.oPicture.TabIndex = 0;
			this.oPicture.TabStop = false;
			this.oPicture.Click += new System.EventHandler(this.oPicture_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Verdana", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Maroon;
			this.label1.Location = new System.Drawing.Point(2, 333);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(256, 40);
			this.label1.TabIndex = 1;
			this.label1.Text = "Shareware";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(6, 375);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(272, 47);
			this.label2.TabIndex = 2;
			this.label2.Text = "This product is distributed as fully functional shareware. It is not free and if " +
				"you choose to use it beyond its 30 day trial period you have to register it.";
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button2.Font = new System.Drawing.Font("Tahoma", 8.25F);
			this.button2.ForeColor = System.Drawing.SystemColors.ActiveCaption;
			this.button2.Location = new System.Drawing.Point(280, 355);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(112, 32);
			this.button2.TabIndex = 4;
			this.button2.Text = "Registration Info";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// btnOK
			// 
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnOK.Location = new System.Drawing.Point(280, 392);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(112, 25);
			this.btnOK.TabIndex = 5;
			this.btnOK.Text = "OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(8, 363);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(160, 8);
			this.groupBox1.TabIndex = 6;
			this.groupBox1.TabStop = false;
			this.groupBox1.Tag = "+";
			// 
			// Splash
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 320);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.oPicture);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Splash";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "West Wind Web Monitor";
			this.Load += new System.EventHandler(this.Splash_Load);
			this.Activated += new System.EventHandler(this.Splash_Activated);
			this.ResumeLayout(false);

		}
		#endregion

		private void Splash_Load(object sender, System.EventArgs e)
		{
#if SHAREWARE
			this.Height = 430;		
			this.oTimer.Enabled = false;
			this.FormBorderStyle = FormBorderStyle.Fixed3D;
			this.TopMost = true;
#endif
			
			Application.DoEvents();

	}

		private void oTimer_Tick(object sender, System.EventArgs e)
		{
			this.TopLevel = false;
			if (this.bSplash) 
			{
				Application.ExitThread();
			}

			this.Close();

		}

		public void SetTopMost() 
		{
			this.TopMost = true;
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			//wwUtils.GoUrl("http://www.west-wind.com/wwstore/item.wws?Sku=WEBMON");
		}

		private void oPicture_Click(object sender, System.EventArgs e)
		{
			#if !SHAREWARE
				this.Close();						
			#endif
		}

		private void Splash_Activated(object sender, System.EventArgs e)
		{
			Application.DoEvents();
		}

	}
}
